**********************************************************************
**********************************************************************
**								    **
**  startup.o replaces gemstart.o for simple programs		    **
**	      it does not implement argc, argv			    **
**								    **
**	      Used with cutil.o, it eliminates aesbind, vdibind,    **
**		   osbind, and gemlib				    **
**								    **
**	      allocates memory for a C or linked asm program	    **
**	      executes main (or _main)				    **
**	      deallocates memory & returns to gem desktop	    **
**								    **
**	      must be the first file in a linked program	    **
**								    **
**********************************************************************
**********************************************************************

* Initialize user's stack
* Compute program memory
.global __cmdln
	.text

	move.l	sp,a5	       use entry stack pointer to get basepage
	lea	ustk,sp        init user's stack
	move.l	4(a5),a5       basepage address. Add prg memory...
	move.l	 #$100,d0	  .basepage len
	add.l	$c(a5),d0	 .text len
	add.l	$14(a5),d0	 .data len
	add.l	$1c(a5),d0	 .bss  len
	lea	129(A5),__cmdln

* call setblock (bdos $4a)

	move.l	d0,-(sp)	   total progam memory
	move.l	a5,-(sp)	   entry stack for pterm ($4c)
	move.w	#0,-(sp)	   ??
	move	#$4a,-(sp)     setblock allocates program memory
	trap	#1
	lea	ustk,sp        reinit user's stack
	jsr	_main	       execute C (or asm) progam

* goto pterm (bdos $4c) to deallocate memory & restore stack
* safety net.  Usually user's program does this)

	move.w	#0,-(sp)
	move.w	#$4c,-(sp)
	trap	#1	       bye, bye

	.bss		       reserve 2k stack
	.even
	ds.l	$800
ustk	ds.l	1
__cmdln ds.l
	.end
