
  .globl  _hex2     hex out
  .globl  _hex4
  .globl  _hex8


*****************************************
*                                       *
* Hex  output routines,                 *
*      On entry: hex value is in d0     *
*                                       *
*****************************************

*****   VOID hex2(num) unsigned integer num;  0<num<$ff !!

_hex2   move.w  4(sp),d0
        move.w  d0,-(sp)        Send d0.b as 2 hex digits
        bra.s   dobyte

*****   VOID hex8(num) unsigned long integer num;  n>$ffff

_hex8
        move.l  d0,-(sp)        Send d0.l as 8 hex digits
        swap    d0                position left 2 bytes
        bsr.s   _hex4              print left 2 bytes
        move.b  #$5f,d0           period between hex words
        bsr     conout
        move.l  (sp)+,d0          fetch for right 2 bytes

*****   VOID hex4(num) unsigned integer num; n<$ffff

_hex4   move.w  d0,-(sp)        Send d0.w as 4 hex digits
        lsr.w   #8,d0             position left word
        lsr.w   #4,d0                 print left nibble
        bsr.s   donibbl
        move.w  (sp),d0           fetch saved word
        lsr.w   #8,d0
        bsr.s   donibbl               print right nibble
dobyte  
        move.w  (sp),d0         Send (sp) as 2 hex digits
        lsr.w   #4,d0
        bsr.s   donibbl           left nibble
        move.w  (sp)+,d0          fetch for right nibble

donibbl and.w   #$0f,d0          Send right nibble
        cmp.b   #9,d0
        bls.s   donibb2
        add.b   #7,d0
donibb2 add.b   #$30,d0
        bra     conout            and rts from conout


